<?php 

/**
 Raspberry Settings Controller
 
 @Copyright 2014 Stefan Rick
 @author Stefan Rick
 Mail: stefan@rick-software.de
 Web: http://www.netzberater.de
 
 No License - see License.txt in Main Plugin Folder
 */

/**
 * 
 * @author Stefan Rick
 *
 */
class Raspberrysettings_Setup extends Service {
		
	public $scriptPath = '';
	public $usbSoundCards = array('' => array('dtoverlay' => '', 'name' => 'none'), 
			'hifiberry-dac' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry DAC (PI A/B)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),	        
			'hifiberry-daclight' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry DAC+ Light (PI 2/3)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
			'hifiberry-dacplus' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry DAC+ (PI 2/3)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
			'hifiberry-dacpluspro' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry DAC+ Pro (PI 2/3)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-dac2pro' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry DAC2 Pro (B+ / PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-dacplushd' =>  array('dtoverlay' => 'hifiberry-dacplushd', 'name' => 'Hifi Berry DAC2 HD (min. Kernel 4.19.97)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-digi' => array('dtoverlay' => 'hifiberry-digi', 'name' => 'Hifi Berry Digi/Digi+', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'hw:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital'),
			'hifiberry-amp' => array('dtoverlay' => 'hifiberry-amp', 'name' => 'Hifi Berry Amp/Amp+', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Master', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-amp2' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Hifi Berry AMP 2 (B+ / PI 2/3)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4:: -o hw:1 -V Digital', 'shairport' => '-d default:CARD=sndrpihifiberry -t hardware -m hw:1 -c Digital', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-amp100' =>  array('dtoverlay' => 'hifiberry-amp100', 'name' => 'Hifi Berry AMP 100 (PI 2/3/4)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4:: -o hw:1 -V Digital -C 5', 'shairport' => '-d default:CARD=sndrpihifiberry -t hardware -m hw:1 -c Digital', 'mpd_device' => 'default:CARD=sndrpihifiberry', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
            'hifiberry-daczero' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry DAC+ Zero (PI A/B)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
	        'hifiberry-miniamp' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Hifi Berry MiniAmp (PI A/B)', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
			'iqaudio-dac' => array('dtoverlay' => 'iqaudio-dac', 'name' => 'IQaudio Card DAC'),
			'iqaudio-dacplus' => array('dtoverlay' => 'iqaudio-dacplus', 'name' => 'IQaudio Pi-DAC+', 'squeezelite' => '-o sysdefault:CARD=IQaudIODAC -a 80:4::', 'shairport' => '-d sysdefault:CARD=IQaudIODAC', 'amixercard' => 'IQaudIODAC'),
	        'iqaudio-dacpluspro' => array('dtoverlay' => 'iqaudio-dacplus', 'name' => 'IQaudIO Pi-DAC+ Pro', 'squeezelite' => '-o sysdefault:CARD=IQaudIODAC -a 80:4::', 'shairport' => '-d sysdefault:CARD=IQaudIODAC', 'mpd_device' => 'sysdefault:CARD=IQaudIODAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'IQaudIODAC'),
			'iqaudio-ampplus' => array('dtoverlay' => 'iqaudio-dacplus', 'name' => 'IQaudio Pi-AMP+/DigiAMP+ (with unmute)', 'squeezelite' => '-o sysdefault:CARD=IQaudIODAC -a 80:4:: -o hw:CARD=IQaudIODAC -V Digital', 'shairport' => '-d sysdefault:CARD=IQaudIODAC -t hardware -m hw:CARD=IQaudIODAC -c Digital', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'IQaudIODAC'),
			'iqaudio-digiplus' => array('dtoverlay' => 'iqaudio-digi-wm8804-audio', 'name' => 'IQaudIO Pi-Digi+', 'squeezelite' => '-o sysdefault:CARD=IQAudIODigi -a 80:4::', 'shairport' => '-d sysdefault:CARD=IQAudIODigi', 'mpd_device' => 'sysdefault:CARD=IQAudIODigi', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'IQAudIODigi'),
			'Audiophonics-I-Sabre-V3' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Audiophonics I-Sabre-V3', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),			
	        'rpi-cirrus-wm5102' => array('dtoverlay' => 'rpi-cirrus-wm5102', 'name' => 'Wolfson Cirrus Logic New (for Kernel 4.4.+)', 'squeezelite' => '-o default:CARD=RPiCirrus -a 80:4::', 'shairport' => '-d default:CARD=RPiCirrus', 'mpd_mixer_control' => 'Speaker Digital' ,'amixercard' => 'RPiCirrus'),
	        'rpi-cirrus-wm5102-overlay' => array('dtoverlay' => 'rpi-cirrus-wm5102-overlay', 'name' => 'OLD Wolfson Cirrus Logic (Kernelchange)', 'squeezelite' => '-o default:CARD=sndrpiwsp -a 80:4::', 'shairport' => '-d default:CARD=sndrpiwsp', 'mpd_mixer_control' => 'Speaker Digital' ,'amixercard' => 'sndrpiwsp'),
			'pifi-dacplus' =>  array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'PiFi DAC+'),
			'snd-usb-asyncaudio' =>  array('dtoverlay' => '', 'name' => 'USB Soundcards (Northstar Essensio, Hiface and others) - takes ~5 minutes to install!'), // https://github.com/panicking/snd-usb-asyncaudio/wiki
			'justboom-digi' => array('dtoverlay' => 'justboom-digi', 'name' => 'JustBoom Digi', 'squeezelite' => '-o sysdefault:CARD=sndrpijustboomd -a 80:4::', 'shairport' => '-d sysdefault:CARD=sndrpijustboomd', 'mpd_device' => 'hw:CARD=sndrpijustboomd,DEV=0', 'mpd_mixer_control' => 'Digital'),
			'justboom-dac' => array('dtoverlay' => 'justboom-dac', 'name' => 'JustBoom DAC', 'squeezelite' => '-o sysdefault:CARD=sndrpijustboomd -a 80:4:: -o hw:CARD=sndrpijustboomd -V Digital', 'shairport' => '-d sysdefault:CARD=sndrpijustboomd -t hardware -m hw:CARD=sndrpijustboomd -c Digital', 'mpd_device' => 'sysdefault:CARD=sndrpijustboomd', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpijustboomd'),
			'justboom-amp' => array('dtoverlay' => 'justboom-dac', 'name' => 'JustBoom AMP', 'squeezelite' => '-o sysdefault:CARD=sndrpijustboomd -a 80:4:: -o hw:CARD=sndrpijustboomd -V Digital', 'shairport' => '-d sysdefault:CARD=sndrpijustboomd -t hardware -m hw:CARD=sndrpijustboomd -c Digital', 'mpd_device' => 'sysdefault:CARD=sndrpijustboomd', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpijustboomd'),
			'raspiplay4' => array('dtoverlay' => 'iqaudio-dacplus', 'name' => 'RaspyPlay4 Hifi Audio Dac', 'squeezelite' => '-o sysdefault:CARD=IQaudIODAC -a 80:4::', 'shairport' => '-d sysdefault:CARD=IQaudIODAC', 'amixercard' => 'IQaudIODAC'),
			'Piano DAC' => array('dtoverlay' => 'allo-piano-dac-pcm512x-audio', 'name' => 'Allo Piano HiFi DAC 2.0', 'squeezelite' => '-o default:CARD=PianoDAC -o hw:CARD=PianoDAC -V Digital -a 80:4::', 'shairport' => '-d default:CARD=PianoDAC', 'mpd_device' => 'default:CARD=PianoDAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'PianoDAC'),
			'Piano DAC Subwoofer' => array('dtoverlay' => 'allo-piano-dac-plus-pcm512x-audio', 'name' => 'Allo Piano HiFi DAC 2.1', 'squeezelite' => '-o default:CARD=PianoDACPlus -o hw:CARD=PianoDACPlus -V Digital -a 80:4::', 'shairport' => '-d sysdefault:CARD=PianoDACPlus -t hardware -m hw:CARD=PianoDACPlus -c Digital', 'mpd_device' => 'default:CARD=PianoDACPlus', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'PianoDACPlus'),
	        'Allo Boss' => array('dtoverlay' => 'allo-boss-dac-pcm512x-audio', 'name' => 'Allo Boss HiFi DAC', 'squeezelite' => '-o default:CARD=BossDAC -o hw:CARD=BossDAC -V Digital -a 80:4::', 'shairport' => '-d default:CARD=BossDAC -t hardware -m hw:CARD=BossDAC -c Digital', 'mpd_device' => 'default:CARD=BossDAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'BossDAC'),
	        'Allo MiniBoss' => array('dtoverlay' => 'allo-boss-dac-pcm512x-audio', 'name' => 'Allo MiniBoss HiFi DAC', 'squeezelite' => '-o default:CARD=BossDAC -o hw:CARD=BossDAC -V Digital -a 80:4::', 'shairport' => '-d default:CARD=BossDAC -t hardware -m hw:CARD=BossDAC -c Digital', 'mpd_device' => 'default:CARD=BossDAC', 'mpd_mixer_control' => 'Digital', 'amixercard' => 'BossDAC'),
	        'Allo Digione' => array('dtoverlay' => 'allo-digione', 'name' => 'Allo Digione', 'squeezelite' => '-o default:CARD=sndallodigione', 'shairport' => '-d default:CARD=sndallodigione', 'mpd_device' => 'default:CARD=sndallodigione'),
	        'mamboberry-hd-DAC' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Mamboberry HD DAC+', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
	        'aroio-dac' => array('dtoverlay' => 'hifiberry-dacplus', 'name' => 'Aroio DAC', 'squeezelite' => '-o sysdefault:CARD=sndrpihifiberry -a 80:4::', 'shairport' => '-d default:CARD=sndrpihifiberry',  'mpd_device' => 'default:CARD=sndrpihifiberry','mpd_mixer_control' => 'Digital', 'amixercard' => 'sndrpihifiberry'),
			'durio-sound-pro' => array('dtoverlay' => 'hifiberry-dac', 'name' => 'Durio Sound Pro'));
	
	public $armFrequency = array(
			'BCM2708' => array(
				'default' => array('name' => 'default (no changes)', 'arm_freq' => 'default'),
				'800' => array('arm_freq' => 800, 'core_freq' => 250, 'sdram_freq' => 400, 'over_voltage' => 0, 'name' => 'Modest'), 
				'900' => array('arm_freq' => 900, 'core_freq' => 250, 'sdram_freq' => 450, 'over_voltage' => 2, 'name' => 'Medium'),
				'950' => array('arm_freq' => 950, 'core_freq' => 250, 'sdram_freq' => 450, 'over_voltage' => 6, 'name' => 'High'),
				'1000'=> array('arm_freq' => 1000,'core_freq' => 500, 'sdram_freq' => 600, 'over_voltage' => 6, 'name' => 'Turbo')
			 ),
			'BCM2709' => array(
				'default' => array('name' => 'default (no changes)', 'arm_freq' => 'default'),
				'1000'=> array('arm_freq' => 1000,'core_freq' => 500, 'sdram_freq' => 500, 'over_voltage' => 2, 'name' => 'Turbo')
			 ),
			'BCM2835' => array(
				'default' => array('name' => 'default (no changes)', 'arm_freq' => 'default')				
			 ),
			'BCM2836' => array(
				'default' => array('name' => 'default (no changes)', 'arm_freq' => 'default')				
			 ),
			'BCM2837' => array(
				'default' => array('name' => 'default (no changes)', 'arm_freq' => 'default')				
			 ));
	public $alsasettings = array(
			'hifiberry-dacplus' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
    	    'hifiberry-amp2' => array(
        	        'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
        	        'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
        	        'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
            'hifiberry-amp100' => array(
                    'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
                    'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
                    'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
	        'hifiberry-dacpluspro' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum 100%)'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum Off)'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
			'hifiberry-dac' => array(
					'PCM' => array('min' => 0, 'max' => 100, 'description' => 'PCM Volume (Optimum 96%)')),			
			'hifiberry-amp' => array(
					'Master' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (Default 80%)')),
			'iqaudio-ampplus' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (Maximum 96%)'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Set to 100%)'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Set to 100%)')),
			'iqaudio-dacplus' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (Optimum 100%)'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Set to 100%)'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Set to 100%)')),
    	    'iqaudio-dacpluspro' => array(
        	        'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (Optimum 100%)'),
        	        'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum 100%)'),
        	        'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)')),
			'raspiplay4' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (Optimum 100%)'),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (set to 0 or 100)'),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Set to 100%)')),
			'Piano DAC' => array(
					'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB)', 'default' => 51),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost (Optimum 100%)', 'valMap' => '[0, 100]', 'default' => 100),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)', 'valMap' => '[0, 100]', 'default' => 100)),
			'Piano DAC Subwoofer' => array(
			        'Master' => array('min' => 0, 'max' => 100, 'description' => 'Master Volume (100 = 0 dB) - synchronized volume changes for Speaker and Subwoofer', 'default' => 51),
			        'Digital' => array('min' => 0, 'max' => 100, 'description' => 'Speaker Volume (100 = 0 dB)', 'default' => 51),
			        'Subwoofer Digital' => array('min' => 0, 'max' => 100, 'description' => 'Subwoofer Volume (100 = 0 dB)', 'default' => 51),
			        'Subwoofer' => array('min' => 0, 'max' => 100, 'description' => 'Subwoofer Volume (100 = 0 dB)', 'default' => 51),
					'Analogue Playback Boost' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Playback Boost', 'valMap' => '[0, 100]', 'default' => 0),
					'Analogue' => array('min' => 0, 'max' => 100, 'description' => 'Analogue Boost (Optimum 100%)', 'valMap' => '[0, 100]', 'default' => 100),
					'Dual Mode' => array('min' => 0, 'max' => 100, 'description' => 'Dual Mode (Double Stereo or Double Mono, need to set Subwoofer to "None"), Default None', 'valMap' => '["None", "Dual-Mono", "Dual-Stereo"]', 'default' => 'None'),
					'Subwoofer mode' => array('min' => 0, 'max' => 100, 'description' => 'Subwoofer Mode (2.0, 2.1, 2.2), Default 2.1', 'valMap' => '["None", "2.0", "2.1", "2.2"]', 'default' => '2.1'),
					'DSP Low pass Program' => array('min' => 60, 'max' => 200, 'description' => 'Subwoofer Cut-Off Frequency (Lowpass filter)', 'valMap' => '[60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200]', 'default' => 90),
					'Lowpass' => array('min' => 60, 'max' => 200, 'description' => 'Subwoofer Cut-Off Frequency (Lowpass filter)', 'valMap' => '[60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200]', 'default' => 90)),
			'pifi-dacplus' => array(
					'PCM' => array('min' => 0, 'max' => 100, 'description' => 'Digital Volume (Optimum value 81 = 0 dB gain, no boost)'))
		    );
	
	public $cirrusoptions = array('Playback_to_Headset', 'Playback_to_Lineout', 'SPDIF_playback', 'Playback_to_Speakers' );
	
	public $gpuMemory = array('BCM2708' => array('min' => '16', 'max' => '512'), 
							  'BCM2709' => array('min' => '16', 'max' => '944'), 
							  'BCM2837' => array('min' => '16', 'max' => '944'), 
					          'BCM2835' => array('min' => '16', 'max' => '944'), 
			                  'BCM2836' => array('min' => '16', 'max' => '944'));	
	
	public function __construct(){
		parent::__construct();
		$this->scriptPath = dirname(__FILE__).'/../scripts/';
		$this->registerLocale(dirname(__FILE__).'/../locale', 'raspberrysettings');		
		
		//Set your Pluginname
		$this->pluginname = _('Raspberry Settings');
		
		if($_REQUEST['ajax'] == 1){			
		    if ($_REQUEST['action'] == 'packageupdate')			
				$this->_upgradeSystem(1);
			elseif($_REQUEST['action'] == 'kernelupdate')			
				$this->_upgradeKernel(1);
			elseif ($_REQUEST['action'] == 'plugininstall')
				$this->_pluginInstall($ajax = 1);
			ob_end_clean();
			echo implode('<br />', $this->view->message);
			ob_flush();
			die();
		}
		
		$this->showHelpSidebar();
		
		if($this->checkLicense(true) == false)
			return true;
				
		if($this->getHardwareInfo() != 'Raspberry PI'){			
			$this->view->message[] = _('This function is for Raspberry PI ONLY! It seems, that you do not have a Raspberry PI.');
			return false;
		}		
		
		//get Configuration for USB-Cards and Performance (CPU / GPU)
		$this->_getDTOverlayConfig();
		
		$this->_getSupportedHDMISettings();
		
		$this->_getCPUGPUConfig();
		
		$this->_getVideoHWEncoding();
		
		if(isset($_GET['action'])){
			if($_GET['action'] == 'save_dtoverlay'){
				$this->_saveDtoverlay();
			}
			if($_GET['action'] == 'save_performance'){
				$this->_saveCPUGPUConfig();
			}
			if($_GET['action'] == 'save_alsa'){
				$this->_saveAlsa();
			}
			if($_GET['action'] == 'setAudioOutputPI'){
				$this->setAudioOutputPI($_GET['AudioOutputPI']);
			}
			if($_GET['action'] == 'saveHDMISettings'){
				$this->_saveHDMISettings();
			}
			if($_GET['action'] == 'save_hwvideo'){
				$this->_saveVideoHWEncoding();
			}
			if($_GET['action'] == 'kernelupdate'){
				$this->_upgradeKernel();
			}	
			if($_GET['action'] == 'packageupdate'){
				$this->_upgradeSystem();
			}
			if($_GET['action'] == 'installbrowser'){
				$this->_installBrowser();
			}
			if ($_REQUEST['action'] == 'plugininstall') {
			    $this->_pluginInstall();
			}
		}		
		
		$this->getAudioOutputPI();
		
		$this->getAlsaAudio();		
		
		//Get Debug Info
		$this->_getAllLogs();
				
	}
	
	/**
	 * Function for Raspberry PI to switch Output between Default, Jack and HDMI
	 * Default: if hdmi is connected it will be choosen
	 */
	private function setAudioOutputPI($value = 0){		
		$this->view->audioOutputPI = $this->writeDynamicScript(array('su -l pi -c \'amixer -c ALSA cset numid=3 '.$value.'\''));
		$this->view->message[] = str_replace('$VALUE',$value, _('Raspberry PI Audio Output set to $VALUE'));		
		return true;
	}
	
	/**
	 * Function for Raspberry PI to get Audio-Output
	 * can be Default=0, Headphone-Jack=1 or HDMI=2
	 */
	private function getAudioOutputPI(){
		if($this->getHardwareInfo() == 'Raspberry PI'){
			$this->view->audioOutputPI = trim($this->writeDynamicScript(array('su -l pi -c \'amixer -c ALSA cget numid=3 | grep ": values=" | sed "s/.*values=//"\'')), "\n");
			return $this->view->audioOutputPI;
		}else
			return false;
	}
	
	private function _getDTOverlayConfig(){
		$this->view->dtoverlay = $this->getConfigFileParameter('/opt/max2play/options.conf', 'audiocard');		
		return true;
	}
	
	private function _getCPUGPUConfig(){
		$this->view->gpu_mem = $this->getConfigFileParameter('/boot/config.txt', 'gpu_mem');
		$this->view->arm_freq = $this->getConfigFileParameter('/boot/config.txt', 'arm_freq');
		$this->view->enable_64bit = $this->getConfigFileParameter('/boot/config.txt', 'arm_64bit');
		$this->view->max_usb_current = $this->getConfigFileParameter('/boot/config.txt', 'max_usb_current');
		$this->view->disable_bluetooth = trim(shell_exec('grep -i "^dtoverlay=pi3-disable-bt" /boot/config.txt | wc -l'));
		$this->view->disable_buildinaudio = trim(shell_exec('grep -i "^dtparam=audio=off" /boot/config.txt | wc -l'));
		$this->view->enable_i2s_mmap = trim(shell_exec('grep -i "^dtoverlay=i2s-mmap" /boot/config.txt | wc -l'));
		
		$kernelOld = true;
		if(method_exists($this, 'Rpi_functions')){
		    $Rpi_functions = $this->Rpi_functions();
		    if (method_exists($Rpi_functions, 'compareKernelVersion')){
		        $kernelOld = $Rpi_functions->compareKernelVersion('4.19.30'); // new GPIO_IR needs at least 4.19.30 in Max2Play
		    }
		}
		if(!$kernelOld){
		    $lircsetup = trim(shell_exec('grep -i "^dtoverlay=gpio-ir" /boot/config.txt'));
		}else{
		    $lircsetup = trim(shell_exec('grep -i "^dtoverlay=lirc-rpi" /boot/config.txt'));
		}		
		if($lircsetup != ''){
			$this->view->enable_lirc = true;
			if(!$kernelOld){
			    // TODO: add dtoverlay=gpio-ir-tx,gpio_pin=18 for transmitting
			    preg_match('@dtoverlay=gpio-ir(,gpio_pin=([0-9]+))?@', $lircsetup, $match);
			}else
			    preg_match('@dtoverlay=lirc-rpi(,gpio_in_pin=([0-9]+))?(,gpio_out_pin=([0-9]+))?@', $lircsetup, $match);
			$this->view->input_lirc = $match[2];
			$this->view->output_lirc = $match[4];
		}else
			$this->view->enable_lirc = false;
		
		$this->view->disable_wifi = trim(shell_exec('grep -i "wlan1" /etc/udev/rules.d/70-persistent-net.rules | wc -l'));
		
		if(file_exists('/etc/sysctl.d/01-disable-ipv6.conf')){
			// Settings for IPv6
			$this->view->disable_ipv6 = 1;
		}else
			$this->view->disable_ipv6 = 0;
		return true;
	}
	
	private function _saveCPUGPUConfig(){
		if(isset($_GET['gpu_mem']) && $_GET['gpu_mem'] <= $this->gpuMemory[$this->info->chipset]['max'] && $this->gpuMemory[$this->info->chipset]['min'] >= 16 && $_GET['gpu_mem'] != $this->view->gpu_mem){
			$this->saveConfigFileParameter('/boot/config.txt', 'gpu_mem', $_GET['gpu_mem']);			
			$this->view->message[] = _t("GPU memory parameter changed");
		}elseif($_GET['gpu_mem'] == ''){
			$this->deleteConfigFileParameter('/boot/config.txt', 'gpu_mem');
			$this->view->message[] = _t("GPU memory parameter removed");
		}
		if(isset($_GET['max_usb_current']) && $this->view->max_usb_current != $_GET['max_usb_current']){
			$this->saveConfigFileParameter('/boot/config.txt', 'max_usb_current', 1);
		}elseif(!isset($_GET['max_usb_current']) && $this->view->max_usb_current == 1){
			$this->deleteConfigFileParameter('/boot/config.txt', 'max_usb_current');
			$this->view->message[] = _t("Max USB-Current parameter removed");
		}
		if(isset($_REQUEST['disable_bluetooth']) && $this->view->disable_bluetooth != $_REQUEST['disable_bluetooth']){
			$this->saveDTOverlayConfig('pi3-disable-bt', 'bluetooth');
		}elseif(!isset($_REQUEST['disable_bluetooth']) && $this->view->disable_bluetooth > 0){
			$this->saveDTOverlayConfig('', 'bluetooth');
		}
		
		if(isset($_REQUEST['enable_i2s_mmap']) && $this->view->enable_i2s_mmap != $_REQUEST['enable_i2s_mmap']){			
			$this->saveDTOverlayConfig('i2s-mmap', 'i2s-mmap');
		}elseif(!isset($_REQUEST['enable_i2s_mmap']) && $this->view->enable_i2s_mmap > 0){
			$this->saveDTOverlayConfig('', 'i2s-mmap');
		}
		
		if(isset($_REQUEST['disable_buildinaudio']) && $this->view->disable_buildinaudio != $_REQUEST['disable_buildinaudio']){
			$this->setBuildInAudio(false);
		}elseif(!isset($_REQUEST['disable_buildinaudio']) && $this->view->disable_buildinaudio > 0){
			$this->setBuildInAudio(true);
		}
		//IPv6
		if(isset($_REQUEST['disable_ipv6']) && $this->view->disable_ipv6 != $_REQUEST['disable_ipv6']){
			$this->writeDynamicScript(array('echo "net.ipv6.conf.all.disable_ipv6 = 1" > /etc/sysctl.d/01-disable-ipv6.conf'));
		}elseif(!isset($_REQUEST['disable_ipv6']) && $this->view->disable_ipv6 > 0){
			$this->writeDynamicScript(array('rm /etc/sysctl.d/01-disable-ipv6.conf'));
		}
		
		// Disable Build in WiFi Raspberry Pi 3
		if(isset($_REQUEST['disable_wifi']) && $this->view->disable_wifi != $_REQUEST['disable_wifi']){
			$this->view->message[] = nl2br($this->writeDynamicScript(array($this->scriptPath.'setwifiname.sh wlan1')));
		}elseif(!isset($_REQUEST['disable_wifi']) && $this->view->disable_wifi > 0){
			$this->view->message[] = nl2br($this->writeDynamicScript(array($this->scriptPath.'setwifiname.sh wlan0')));
		}
		
		// Enable / Disable Lirc in Raspberry Pi
		if(isset($_REQUEST['enable_lirc']) && $this->view->enable_lirc != $_REQUEST['enable_lirc'] || isset($_REQUEST['enable_lirc']) && ($_REQUEST['input_lirc'] != $this->view->input_lirc || $_REQUEST['output_lirc'] != $this->view->output_lirc)){
		    $kernelOld = true;
		    if(method_exists($this, 'Rpi_functions')){
		        $Rpi_functions = $this->Rpi_functions();
		        if (method_exists($Rpi_functions, 'compareKernelVersion')){
		            $kernelOld = $Rpi_functions->compareKernelVersion('4.19.30'); // new GPIO_IR needs at least 4.19.30 in Max2Play
		        }
		    }
		    if(!$kernelOld){
		        $this->saveDTOverlayConfig('gpio-ir,gpio_pin='.$_REQUEST['input_lirc'], 'lirc');
		    }else{
		        $this->saveDTOverlayConfig('lirc-rpi,gpio_in_pin='.$_REQUEST['input_lirc'].',gpio_out_pin='.$_REQUEST['output_lirc'], 'lirc');
		    }			
		}elseif(!isset($_REQUEST['enable_lirc']) && $this->view->enable_lirc > 0){
			$this->saveDTOverlayConfig('', 'lirc');
		}
		
		if(isset($_GET['arm_freq']) && in_array($_GET['arm_freq'], array_keys($this->armFrequency[$this->info->chipset]))){
			if($_GET['arm_freq'] == 'default'){
				$this->deleteConfigFileParameter('/boot/config.txt', 'arm_freq');
				$this->deleteConfigFileParameter('/boot/config.txt', 'core_freq');
				$this->deleteConfigFileParameter('/boot/config.txt', 'sdram_freq');
				$this->deleteConfigFileParameter('/boot/config.txt', 'over_voltage');
			}else{
				$values = $this->armFrequency[$this->info->chipset][$_GET['arm_freq']];
				$this->saveConfigFileParameter('/boot/config.txt', 'arm_freq', $values['arm_freq']);
				$this->saveConfigFileParameter('/boot/config.txt', 'core_freq', $values['core_freq']);
				$this->saveConfigFileParameter('/boot/config.txt', 'sdram_freq', $values['sdram_freq']);
				$this->saveConfigFileParameter('/boot/config.txt', 'over_voltage', $values['over_voltage']);				
			}
			//$this->view->message[] = _("ARM-Frequency parameter changed");
		}
		
		$this->getLinuxVersion();
		if(isset($this->info->linux[1]) && $this->info->linux[0] == "Raspbian" && $this->info->linux[1] == "buster"){
    		// Only for Pi4 and Buster Image
		    if(isset($_REQUEST['enable_64bit']) && $this->view->enable_64bit != $_REQUEST['enable_64bit']){		    
    		    $this->saveConfigFileParameter('/boot/config.txt', 'arm_64bit', '1');
    		}elseif(!isset($_REQUEST['enable_64bit']) && $this->view->enable_64bit > 0){		    
    		    $this->saveConfigFileParameter('/boot/config.txt', 'arm_64bit', '0');	 
    		}
		}
		$this->view->message[] = _('Reboot needed');
		$this->_getCPUGPUConfig();
		return true;
	}
	
	private function _saveDtoverlay(){
		if(isset($_GET['dtoverlay']) && in_array($_GET['dtoverlay'], array_keys($this->usbSoundCards)) && $this->view->dtoverlay != $_REQUEST['dtoverlay']){
			if($_GET['dtoverlay'] == 'rpi-cirrus-wm5102-overlay'){
				// At least Kernel 4+ needed
			    $kernel4=trim(shell_exec('uname --all | grep " 4\." | wc -l'));
				if($this->info->chipset == 'BCM2708' && $kernel4 == 0){
					$kernel = 'kernel-cirrus-rpi1.deb';					
					$this->saveConfigFileParameter('/boot/config.txt', 'kernel', "vmlinuz-3.18.9cludlmmapfll");
				}elseif(($this->info->chipset == 'BCM2709' || $this->info->chipset == 'BCM2837') && $kernel4 == 0){
					$kernel = 'kernel-cirrus-rpi2.deb';
					$this->saveConfigFileParameter('/boot/config.txt', 'kernel', "vmlinuz-3.18.9-v7cludlmmapfll");
				}
				
				//Check for Kernel 4.4.y
				$kernelversion = explode('.',trim($this->shell_exec('uname --all | grep -oe " [0-9]\+\.[0-9\.]\+"')));
				$minkernel = array(0 => 4, 1 => 4, 2 => 1);
				$kernel44=true;
				foreach($minkernel as $key => $min){
				    if(isset($kernelversion[$key]) && $kernelversion[$key] >= $min){
				        // OK
				    }else{
				        $kernel44=false;
				    }
				}		
				
				if($kernel44 == true){
					// New from Kernel 4.4 -> renamed DTOVERLAY for Cirrus Driver
				    $_GET['dtoverlay'] = 'rpi-cirrus-wm5102';
				    $this->usbSoundCards[$_GET['dtoverlay']]['dtoverlay'] = 'rpi-cirrus-wm5102';
					$kernel = "none";
				}
				$this->writeDynamicScript(array($this->scriptPath.'install_wolfson_kernel.sh '.$kernel));
				$this->view->message[] = _t('IMPORTANT: You will have more options on this page for setting up your wolfson audiocard after reboot. This includes choosing the prefered output (headphones / lineout / SPDIF).');
			}elseif($_GET['dtoverlay'] == 'rpi-cirrus-wm5102'){
			    $this->writeDynamicScript(array($this->scriptPath.'install_wolfson_kernel.sh none'));
			    $this->view->message[] = _t('IMPORTANT: You will have more options on this page for setting up your wolfson audiocard after reboot. This includes choosing the prefered output (headphones / lineout / SPDIF).');
			}else{
				if(strpos($this->getConfigFileParameter('/boot/config.txt', 'kernel'), 'cludlmmapfll') !== FALSE){
					$this->saveConfigFileParameter('/boot/config.txt', 'kernel', '');
				}
			}
			if($_GET['dtoverlay'] == 'snd-usb-asyncaudio'){				
				$this->view->message[] = nl2br($this->writeDynamicScript(array($this->scriptPath.'install_usb-soundcard.sh '.$this->info->chipset)));			
			}
			if($_GET['dtoverlay'] == 'iqaudio-ampplus'){
				//Unmute on Startup -> rc.local
				$this->writeDynamicScript(array('sed -i \'s@^exit 0@echo "Unmute iqaudio-ampplus";echo "22" > /sys/class/gpio/export;echo "out" >/sys/class/gpio/gpio22/direction;echo "1" >/sys/class/gpio/gpio22/value;\nexit 0@\' /etc/rc.local'));
			}else{
				//Remove unmute from rc.local
				$this->writeDynamicScript(array('sed -i \'s@.*Unmute iqaudio-ampplus.*@@\' /etc/rc.local'));
			}
			if($this->usbSoundCards[$_GET['dtoverlay']]['dtoverlay'] == ''){
				//Remove dtoverlay Parameter if set to empty value
				$this->saveDTOverlayConfig('', 'soundcard');
				//$this->deleteConfigFileParameter('/boot/config.txt', 'dtoverlay');
			}else{
				$this->saveDTOverlayConfig($this->usbSoundCards[$_GET['dtoverlay']]['dtoverlay'], 'soundcard');
				//$this->saveConfigFileParameter('/boot/config.txt', 'dtoverlay', $this->usbSoundCards[$_GET['dtoverlay']]['dtoverlay']);
			}
			if(isset($this->usbSoundCards[$_REQUEST['dtoverlay']]['squeezelite']))
				$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SQUEEZELITE_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['squeezelite']);
			if(isset($this->usbSoundCards[$_REQUEST['dtoverlay']]['shairport'])){
				$this->saveConfigFileParameter('/opt/max2play/audioplayer.conf', 'SHAIRPORT_PARAMETER', $this->usbSoundCards[$_REQUEST['dtoverlay']]['shairport']);
			}
			
			if(file_exists('/etc/mpd.conf') && isset($this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_device'])){
			    $this->saveConfigFileParameter('/etc/mpd.conf', $parameter = 'device', $value = '\"'.$this->usbSoundCards[$_REQUEST['dtoverlay']]['mpd_device'].'\"', $separator = '\\t');			    
			}					
			$this->saveConfigFileParameter('/opt/max2play/options.conf', 'audiocard', $_GET['dtoverlay']);
			$this->view->message[] = _("Boot config parameters changed");
			$this->view->message[] = _('Reboot needed');
			$this->view->message[] = _t('After Reboot, you need to change the soundcard settings for your audioplayer. This can be done in tab "Audioplayer" -> "Advanced Settings" for Squeezelite or Shairport.');
			$this->view->message[] = _t('If your soundcard doesn\'t allow multiple players to access it at the same time: remove other audioplayers (e.g. Shairport) from autostart and stop them. If you want Airplay and Squeezelite you can activate the Shairtunes Plugin for Squeezebox Server on the Squeezebox Server tab of the Max2Play-Webinterface.');
			
		}
		$this->_getDTOverlayConfig();
		return true;
	}

	/**
	 * get Alsa Settings For AudioCard
	 */
	public function getAlsaAudio(){		
		$this->view->alsavalues = false;
		if($this->view->dtoverlay && isset($this->alsasettings[$this->view->dtoverlay])){
			$user = $this->getSystemUser();
			if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
				$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
			}else{
				$amixercard = '';
			}
			foreach($this->alsasettings[$this->view->dtoverlay] as $key => $value){
				$script = array('su - '.$user.' -c \'amixer -M '.$amixercard.' sget "'.$key.'"\'');
				$output = $this->writeDynamicScript($script);
				preg_match('=\[([^\]]*)\]|Item0: \'([0-9a-zA-Z\-\\.]+)\'=', $output, $match);
				if(isset($match[2])){
					$this->view->alsavalues[$key] = $value;
					$this->view->alsavalues[$key]['type'] = '';					
					$this->view->alsavalues[$key]['value'] = $match[2];					
				}elseif(isset($match[1])){
					$this->view->alsavalues[$key] = $value;
					if(strpos($match[1], '%') !== FALSE)
						$this->view->alsavalues[$key]['type'] = '%';
					else
						$this->view->alsavalues[$key]['type'] = '';
					$this->view->alsavalues[$key]['value'] = intval($match[1]);
				}
			}
		}
		if($this->view->dtoverlay == 'rpi-cirrus-wm5102-overlay'){			
			$user = $this->getSystemUser();
			$script = array('su - '.$user.' -c \'amixer -Dhw:sndrpiwsp sget "HPOUT1 Digital Volume"\'');
			$output = $this->writeDynamicScript($script);
			preg_match('=\[([^\]]*)\]=', $output, $match);
			if(isset($match[1])){
				$this->view->wolfson_active = true;
			}
			//TODO: Override temporary off
			$this->view->wolfson_active = true;
		}
		if($this->view->dtoverlay == 'rpi-cirrus-wm5102'){
		    $this->view->wolfson_active = true;
		}
		return true;
	}
	
	public function _saveAlsa(){
		$user = $this->getSystemUser();
		$this->getAlsaAudio();
		$script = array();
		if($this->view->dtoverlay != 'rpi-cirrus-wm5102-overlay'){
			if(isset($this->usbSoundCards[$this->view->dtoverlay]['amixercard'])){
				$amixercard = ' -c '.$this->usbSoundCards[$this->view->dtoverlay]['amixercard'].' ';
			}else{
				$amixercard = '';
			}
			foreach($this->view->alsavalues as $key => $value){			
				$script[] = 'su - '.$user.' -c \'amixer -M '.$amixercard.' -q set "'.$key.'" '.$_REQUEST[str_replace(' ','_', $key)].$value['type'].'\'';
				$script[] = 'su - '.$user.' -c \'alsactl store\'';
			}
		}
		if(isset($_REQUEST['cirrus-option']) && in_array($_REQUEST['cirrus-option'], $this->cirrusoptions)){			
			$script[] = 'su - '.$user.' -c \'/opt/max2play/wolfson/'.$_REQUEST['cirrus-option'].'.sh 2>&1\'';
		}
		if(isset($script[0])){
			$output = nl2br($this->writeDynamicScript($script));
			if($output != '')
				$this->view->message[] = $output;
			$this->view->message[] = _("Updated Alsa Settings");
		}
		return true;
	}
	
	/**
	 * get some Debug Output and save it for view
	 */
	private function _getAllLogs(){		
		// TODO: read and print some Values http://www.maketecheasier.com/finding-raspberry-pi-system-information/
		// $out['PARAMETERS - TEMPERATURE'] = shell_exec('vcgencmd measure_temp');
		$out['BOOT CONFIG TXT'] = shell_exec('cat /boot/config.txt');
	
		$this->view->debug = $out;
	}
	
	/**
	 * get valid settings for HDMI
	 */
	private function _getSupportedHDMISettings(){
		$this->view->supported_hdmi_modes = array();
		$mode1 = $this->writeDynamicScript(array('/opt/vc/bin/tvservice -m CEA'));
		// Array $matches: 1=prefer/native 2=hdmi_mode 3=settings
		preg_match_all('=(\(.*\))? mode ([0-9]+): ([^,]*),=', $mode1, $matches);
		$cm = count($matches[0]);
		for($i=0; $i < $cm; $i++){
			$this->view->supported_hdmi_modes[] = array('hdmi_setup' => $matches[2][$i].'_1', 'hdmi_group' => 1, 'details' => $matches[3][$i].($matches[1][$i] != '' ? ' '.$matches[1][$i] : ''));
		}
		$mode2 = $this->writeDynamicScript(array('/opt/vc/bin/tvservice -m DMT'));
		preg_match_all('=(\(.*\))? mode ([0-9]+): ([^,]*),=', $mode2, $matches);
		$cm = count($matches[0]);
		for($i=0; $i < $cm; $i++){
			$this->view->supported_hdmi_modes[] = array('hdmi_setup' => $matches[2][$i].'_2', 'hdmi_group' => 2, 'details' => $matches[3][$i].($matches[1][$i] != '' ? ' '.$matches[1][$i] : ''));
		}
		
		//get current mode and group setting
		$this->view->hdmi_setup = $this->getConfigFileParameter('/boot/config.txt', 'hdmi_mode').'_'.$this->getConfigFileParameter('/boot/config.txt', 'hdmi_group');
		
		$this->view->hdmi_drive = $this->getConfigFileParameter('/boot/config.txt', 'hdmi_drive');
		
		$this->view->hdmi_force_hotplug = $this->getConfigFileParameter('/boot/config.txt', 'hdmi_force_hotplug');
		
		$this->view->disable_overscan = $this->getConfigFileParameter('/boot/config.txt', 'disable_overscan');
		
		$this->view->avoid_warnings = $this->getConfigFileParameter('/boot/config.txt', 'avoid_warnings');
		
		$this->view->screen_sleep = $this->getConfigFileParameter('/etc/lightdm/lightdm.conf', 'xserver-command');
		
		$this->view->enable192khzHDMI = $this->getConfigFileParameter('/boot/config.txt', 'kernel');
		
		return true;		
	}
	
	/**
	 * get valid settings for HDMI
	 */
	private function _saveHDMISettings(){
		if(isset($_REQUEST['hdmi_setup']) && $_REQUEST['hdmi_setup'] != '' && $_REQUEST['hdmi_setup'] != $this->view->hdmi_setup){
			//Request Parameter consists of mode_group
			$hdmi = explode('_',$_REQUEST['hdmi_setup']);
			if($hdmi[0] != false && $hdmi[1] != false){
				$this->saveConfigFileParameter('/boot/config.txt', 'hdmi_mode', $hdmi[0]);
				$this->saveConfigFileParameter('/boot/config.txt', 'hdmi_group', $hdmi[1]);
				$this->view->message[] = _t("HDMI-Settings for Raspberry PI changed! Reboot needed!");
				$this->_getSupportedHDMISettings();			
			}else{
				// Set default values
				$this->deleteConfigFileParameter('/boot/config.txt', 'hdmi_mode');
				$this->deleteConfigFileParameter('/boot/config.txt', 'hdmi_group');
			}
		}
		
		// DVI or HDMI
		if($_REQUEST['hdmi_drive'] != $this->view->hdmi_drive){
			if($this->view->hdmi_drive && $_REQUEST['hdmi_drive'] == '')
				$this->deleteConfigFileParameter('/boot/config.txt', 'hdmi_drive');				
			elseif($_REQUEST['hdmi_drive'] != '')
				$this->saveConfigFileParameter('/boot/config.txt', 'hdmi_drive', $_REQUEST['hdmi_drive']);
			$this->view->hdmi_drive = $_REQUEST['hdmi_drive'];
		}
		
		if($_REQUEST['hdmi_force_hotplug'] != $this->view->hdmi_force_hotplug){
			if(isset($_REQUEST['hdmi_force_hotplug']) && $_REQUEST['hdmi_force_hotplug'] == 1)
				$this->saveConfigFileParameter('/boot/config.txt', 'hdmi_force_hotplug', '1');
			else
				$this->deleteConfigFileParameter('/boot/config.txt', 'hdmi_force_hotplug');
			$this->view->hdmi_force_hotplug = $_REQUEST['hdmi_force_hotplug'];
		}
		
		if($_REQUEST['disable_overscan'] != $this->view->disable_overscan){
			if(isset($_REQUEST['disable_overscan']) && $_REQUEST['disable_overscan'] == 1)
				$this->saveConfigFileParameter('/boot/config.txt', 'disable_overscan', '1');
			else 
				$this->deleteConfigFileParameter('/boot/config.txt', 'disable_overscan');
			$this->view->disable_overscan = $_REQUEST['disable_overscan'];
		}
		if($_REQUEST['screen_sleep'] != $this->view->screen_sleep){
			if(isset($_REQUEST['screen_sleep']) && $_REQUEST['screen_sleep'] == 'X -s 0 dpms'){
				$this->writeDynamicScript(array('sed -i "s@\[SeatDefaults\]@\[SeatDefaults\]\nxserver-command=X -s 0 dpms@" /etc/lightdm/lightdm.conf'));
				$this->view->message[] = _t("Screen Sleep changed");
			}
			else
				$this->deleteConfigFileParameter('/etc/lightdm/lightdm.conf', 'xserver-command');
			$this->view->screen_sleep = $_REQUEST['screen_sleep'];
		}
		if($_REQUEST['avoid_warnings'] != $this->view->avoid_warnings){
			if(isset($_REQUEST['avoid_warnings']) && $_REQUEST['avoid_warnings'] == '1'){
				$this->saveConfigFileParameter('/boot/config.txt', 'avoid_warnings', '1');
			}
			else
				$this->saveConfigFileParameter('/boot/config.txt', 'avoid_warnings', '0');
			$this->view->avoid_warnings = $_REQUEST['avoid_warnings'];
		}
				
		if($_REQUEST['enable192khzHDMI'] != $this->view->enable192khzHDMI){
			// ONLY ON WHEEZY - build new Kernel for Jessie!
			$this->getLinuxVersion();
			if(isset($this->info->linux[1]) && $this->info->linux[0] == "Raspbian" && ($this->info->linux[1] == "jessie" || $this->info->linux[1] == "stretch" || $this->info->linux[1] == "buster"))
				$jessie = true;
			else
				$jessie = false;
			if($_REQUEST['enable192khzHDMI'] !== '' && !$jessie){
				//for different Kernel Versions get different Kernels
				$kernel41=trim(shell_exec('uname --all | grep " 4.1." | wc -l'));
				if($kernel41 > 0){
					$this->view->message[] = $this->writeDynamicScript(array($this->scriptPath.'install_kernel.sh '.$this->info->chipset.' 192khzenabled'));
				}else{
					$script[] = 'wget -O /opt/max2play/cache/kernel.tgz shop.max2play.com/media/downloadable/currentversion/wolfsonkernel/Kernel3.18.9.v7-192khz.tgz';				
					$script[] = 'tar xzf /opt/max2play/cache/kernel.tgz -C /opt/max2play/cache/;mv /opt/max2play/cache/kernel7.img /boot/kernel7m2p.img;mv /opt/max2play/cache/kernel.img /boot/kernelm2p.img;tar xzf /opt/max2play/cache/modules.tgz -C /';
					$this->writeDynamicScript($script);

					if($this->info->chipset == 'BCM2708')
						$this->saveConfigFileParameter('/boot/config.txt', 'kernel', 'kernelm2p.img');
					else
						$this->saveConfigFileParameter('/boot/config.txt', 'kernel', 'kernel7m2p.img');
				}
				$this->view->message[] = _t('New Max2Play Kernel installed. Please reboot device!');
			}elseif($jessie){
				$this->view->message[] = _t('Kernel Change is not yet supported on Debian Jessie - we are working on this!');
			}else{				
				$this->saveConfigFileParameter('/boot/config.txt', 'kernel', '');
				$this->view->message[] = _t('Standard Kernel installed. Please reboot device!');
			}
			$this->view->enable192khzHDMI = $this->getConfigFileParameter('/boot/config.txt', 'kernel');
			
		}
		
		return true;
	}
	
	private function _saveVideoHWEncoding(){
		if($this->view->mpeg2_key != $_REQUEST['mpeg2_key']){
			$this->saveConfigFileParameter('/boot/config.txt', 'decode_MPG2', preg_replace('=[^a-zA-Z0-9]=','', $_REQUEST['mpeg2_key']));
		}
		if($this->view->vc1_key != $_REQUEST['vc1_key']){
			$this->saveConfigFileParameter('/boot/config.txt', 'decode_WVC1', preg_replace('=[^a-zA-Z0-9]=','', $_REQUEST['vc1_key']));
		}
		$this->_getVideoHWEncoding();
		$this->view->message[] = _('Reboot needed!');
	}
	
	private function _getVideoHWEncoding(){
		$this->view->serialnumber = trim(shell_exec("cat /proc/cpuinfo | grep Serial | sed 's/.*: //'"), "\n");
		$status = $this->writeDynamicScript(array('vcgencmd codec_enabled MPG2;vcgencmd codec_enabled WVC1'));
		$s = explode("\n", $status);
		$this->view->mpeg2_status = $s[0];
		$this->view->vc1_status = $s[1];
		$this->view->mpeg2_key = $this->getConfigFileParameter('/boot/config.txt', 'decode_MPG2');
		$this->view->vc1_key = $this->getConfigFileParameter('/boot/config.txt', 'decode_WVC1');
		return true;
	} 
	
	public function showHelpSidebar(){
		global $helpSidebar;
		$helpSidebar['title'] = _t('Help - Raspberry Settings');
		$helpSidebar['content'] = _t('<ul><li><a href="https://youtu.be/uIb56VeGCP0" target="blank">Watch a video showing Raspberry PI Settings on Max2Play</a></li><li>Use this page to enable your audiocard. Once enabled make sure, that you also set up your prefered audioplayer to use this audiocard! Otherwise the output of your sound will still go to the default output (e.g. HDMI, headphone)</li></ul>');
		return true;
	}
		
	private function _installBrowser($ajax = 0){
		$shellanswer = nl2br($this->writeDynamicScript(array("apt-get update && apt-get install iceweasel -y")));
		$this->view->message[] = $shellanswer;
		$this->view->message[] = _('Browser installed.');
		return true;
	}
	
	/**
	 * Update & Upgrade System
	 * @return boolean
	 */
	private function _upgradeSystem($ajax = 0){
		$outfile = '/opt/max2play/cache/upgradeSystem.txt';
		if($ajax == 0){
			ignore_user_abort(true);
			set_time_limit(3000);
			$this->view->message[] = _('Update / Upgrade to latest Version started');
			if($this->getProgressWithAjax($outfile, 1, 0)){
				//run it as a deamon to enable apache updates
				$shellanswer = $this->writeDynamicScript(array("export DEBIAN_FRONTEND=noninteractive;dpkg --configure -a >> ".$outfile." 2>&1; apt-get update >> ".$outfile." 2>&1;apt-get -y upgrade >> ".$outfile." 2>&1;echo 'Finished - Reboot needed! <b><a href=\"/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/raspberrysettings/controller/Setup.php\">Click here to Reboot Now</a></b>' >> ".$outfile), false, true);
			}
		}else{
			$status = $this->getProgressWithAjax($outfile, 0, 0, 30);
			$this->view->message[] = nl2br($status);
			if(strpos($status, 'Finished') !== FALSE){
				//Finished Progress - did not delete progressfile
				$this->view->message[] = _('UPDATE ENDED - CHECK ABOVE LOG FOR ERRORS');
				shell_exec('rm '.$outfile);
			}
		}
		return true;
	}
	
	/**
	 * Update & Upgrade System
	 * @return boolean
	 */
	private function _upgradeKernel($ajax = 0){
		$outfile = '/opt/max2play/cache/upgradeSystem.txt';
		if($ajax == 0){
			ignore_user_abort(true);
			set_time_limit(3000);
			$this->view->message[] = _('Kernel Update started');
			if($this->getProgressWithAjax($outfile, 1, 0)){
				//run it as a deamon to enable apache updates
				$kernel41=0; //trim(shell_exec('uname --all | grep " 4.1." | wc -l'));
				if($kernel41 > 0){					
					// video drivers are missing in M2P-Kernel Build -> check before activating this
					$shellanswer = $this->writeDynamicScript(array($this->scriptPath.'install_kernel.sh '.$this->info->chipset." >> ".$outfile." 2>&1;echo 'Finished - Reboot needed! <b><a href=\"/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/raspberrysettings/controller/Setup.php\">Click here to Reboot Now</a></b>' >> ".$outfile), false, true);
				}else{
					// REPO_URI=https://github.com/notro/rpi-firmware  ersetzt durch Default					
					$shellanswer = $this->writeDynamicScript(array("echo -e \"y\\n\" | rpi-update >> ".$outfile." 2>&1;echo 'Finished - Reboot needed! <b><a href=\"/plugins/max2play_settings/controller/Basic.php?action=reboot&redirecturl=/plugins/raspberrysettings/controller/Setup.php\">Click here to Reboot Now</a></b>' >> ".$outfile), false, true);
				}
			}
		}else{
			$status = $this->getProgressWithAjax($outfile, 0, 0, 30);
			$this->view->message[] = nl2br($status);
			if(strpos($status, 'Finished') !== FALSE){
				//Finished Progress - did not delete progressfile				
				if(strpos($status, 'Raspberry Pi firmware updater') !== FALSE && strpos($status, 'Your firmware is already up to date') === FALSE){
					// Unset Parameter Kernel in Boot/config.txt if set
					$this->deleteConfigFileParameter('/boot/config.txt', 'kernel');
					$this->view->message[] = _('Custom parameter Kernel removed');
				}
				$this->view->message[] = _('UPDATE ENDED - CHECK ABOVE LOG FOR ERRORS');
				shell_exec('rm '.$outfile);
			}
		}
		return true;
	}
	
	/**
	 * Important! dtoverlay Parameter might be set multiple times in config.txt -> separate handling needed
	 * @param string $value
	 * @param string $dto_type Possible values: soundcard, single_option
	 * @return boolean
	 */
	private function saveDTOverlayConfig($value = '', $dto_type = 'notset'){	    
	    $dto_entries['soundcard'] = array();
		$dto_entries['i2s-mmap'] = array('i2s-mmap'); // Support for Alsa DMIX on Soundcards
		$dto_entries['bluetooth'] = array('pi3-disable-bt');
		$dto_entries['display'] = array('vc4-fkms-v3d');
		$dto_entries['lirc'] = array(		     
		    'lirc-rpi(,gpio_in_pin=[0-9]+)?(,gpio_out_pin=[0-9]+)?',
		    'gpio-ir(,gpio_pin=[0-9]+)?'
		);
		$dto_value = '';
		$separator = '=';
		$configfile = '/boot/config.txt';
		$parameter = 'dtoverlay';
		// fill possible soundcard values
		foreach($this->usbSoundCards as $card){
			if (isset($card['dtoverlay']) && $card['dtoverlay'] != '')
				$dto_entries['soundcard'][] = $card['dtoverlay'];
		}
		if(file_exists($configfile)){
			$old_parameter = explode("\n", trim($this->getConfigFileParameter($configfile, $parameter)));
			// $old_parameter is an array
			// get the right value to replace / add new			
			foreach($old_parameter as $oldparam){
				if($dto_type == 'lirc'){
					// pattern recognition for flexible parameter values
					foreach($dto_entries[$dto_type] as $type){
						if(preg_match('@'.$type.'@', $oldparam, $match)){
							$dto_value = $oldparam;
						}
					}
				}else{
					// normal recognition
					if(in_array($oldparam, $dto_entries[$dto_type])){
						$dto_value = $oldparam;
					}
				}
				
				if($oldparam == $value){
					//Value existing -> do not change!
					return true;
				}				
			}		
			
			if($dto_value != '' && $value == ''){
				// Remove by oldvalue
				$this->writeDynamicScript(array('sed -i "s/^[ \t]*'.$parameter.$separator.$dto_value.'$//g" '.$configfile));				
				$this->view->message[] = _("Update Configfile - existing Entry removed");
			}elseif($dto_value == ''){				
				// Add new
				$this->writeDynamicScript(array('echo "'.$parameter.$separator.$value.'" >> '.$configfile));
				$this->view->message[] = _("Update Configfile - new Entry created");
			}else{
				// Replace by old value
				$this->writeDynamicScript(array('sed -i "s/^[ \t]*'.$parameter.$separator.$dto_value.'$/'.$parameter.$separator.str_replace(array('/'),array('\/'),$value).'/g" '.$configfile));
				$this->view->message[] = _("Update Configfile - existing Entry changed");
			}
		}
		return true;
	}
	
	/**
	 * 1-Click-Installer for other modules
	 */
	private function _pluginInstall($ajax = 0)
	{
	    ignore_user_abort(true);
	    set_time_limit(1800);
	    
	    if ($_REQUEST['piplugin'] == 'pijuice-base' || $_REQUEST['piplugin'] == 'pijuice-gui') {
            if ($ajax == 0) {
                if ($this->getProgressWithAjax('/opt/max2play/cache/install_pijuice.txt', 1, 1, 30, $message = false, $url = false, $failmessage = false, $finishedText = 'Finished Installing')) {
                    $shellanswer = $this->writeDynamicScript(array(
                        $this->scriptPath . "install_pijuice.sh ".str_replace('pijuice-', '',$_REQUEST['piplugin'])." >> /opt/max2play/cache/install_pijuice.txt 2>&1 &"
                    ), false, true);
                }
            } else {
                $status = $this->getProgressWithAjax('/opt/max2play/cache/install_pijuice.txt', 0, 1, 30);
                $this->view->message[] = nl2br($status);
                if (strpos($status, 'Finished Installing') !== FALSE) {
                    // Finished Progress - did not delete progressfile yet                    
                    shell_exec('rm /opt/max2play/cache/install_pijuice.txt');
                }
            }
        }
        return true;
	}
	
}

//Create an instance of your Class
$rs = new Raspberrysettings_Setup();

//This Line includes the View-Script -> it should have the same name as your class
include_once(dirname(__FILE__).'/../view/setup.php');

