#!/bin/bash

# $1 = PI Version

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# get current Kernel Version
KERNEL41=$(uname --all | grep " 4.1." | wc -l) 

if [ "$KERNEL41" -gt "0" ]; then
	if [ "$1" == "BCM2709" -o "$1" == "BCM2837" ]; then
		if [ "$2" == "192khzenabled" ]; then
			wget -O /opt/max2play/cache/Kernel-M2P-4.1.13-v7+.deb http://shop.max2play.com/media/downloadable/currentversion/Kernel-M2P-192khz-4.1.13-v7+.deb
		else
			wget -O /opt/max2play/cache/Kernel-M2P-4.1.13-v7+.deb http://shop.max2play.com/media/downloadable/currentversion/Kernel-M2P-4.1.13-v7+.deb
		fi
		# Check for correct download and size and remove Old Kernelfiles from Boot folder
		if [ ! -e /opt/max2play/cache/Kernel-M2P-4.1.13-v7+.deb ]; then
			echo "ERROR: Kernel could not be downloaded!"
			exit 0
		else
			# If not deleted dpgk will report an error on install
			rm /boot/kernel-m2p-4.1.13-v7+.img
		fi
		dpkg -i --force-overwrite /opt/max2play/cache/Kernel-M2P-4.1.13-v7+.deb
		# set Kernel Image to use to kernel-4.1.13-v7+.img
		if [ "$(grep -i 'kernel=' /boot/config.txt | wc -l)" -gt "0" ]; then
			sed -i 's/kernel=.*/kernel=kernel-m2p-4.1.13-v7+.img/' /boot/config.txt
		else
			echo "kernel=kernel-m2p-4.1.13-v7+.img" >> /boot/config.txt
		fi
		echo "Kernel Changed"
		exit 1
	else
		echo "Not Supported - only for New Raspberry B+ / 2"
		exit 1
	fi
fi
