#!/bin/bash

# $1 = PI Version

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

echo "This installer for USB-Hiface Soundcards installs the latest Kernel official Kernel with Kernel Headers, compiles a modified module and sets this module (snd-usb-hiface) to autostart - this might take a while..." 
echo ""

# Restore to latest Kernel that offers kernel headers		
apt-get update
apt-get install --reinstall raspberrypi-bootloader raspberrypi-kernel -y
apt-get install raspberrypi-kernel-headers build-essential git -y

# link Kernel Headers to build directory (workaround to skip reboot)
BUILDDIRV7=$(find /lib/modules | grep build | grep v7 | head -1)
KERNEL=$(uname -r)
# example: ln /lib/modules/4.9.35-v7+/build /lib/modules/4.9.39-v7+/build
if [ ! -e /lib/modules/$KERNEL/build ]; then
	ln $BUILDDIRV7 /lib/modules/$KERNEL/build
fi

cd /opt/
git clone git://github.com/panicking/snd-usb-asyncaudio.git
cd snd-usb-asyncaudio/
# apply patch to chip.c (snd_card_new device)
sed -i 's@ret = snd_card_create(@ret = snd_card_new(\&device->dev, @' chip.c
make

MODPATH=/opt/snd-usb-asyncaudio/snd-usb-hiface.ko

if [ $(grep "$MODPATH" -i /etc/rc.local | wc -l) -lt "1" ]; then
	sudo sed -i "s@^exit 0@#Max2Play Module\ninsmod $MODPATH\n\nexit 0@" /etc/rc.local
fi

#insmod $MODPATH

echo "finished - reboot needed!";
