#!/bin/bash

# $1 = Kernelpath

source=$1
overlay="rpi-cirrus-wm5102-overlay.dtb"
scripts="use_case_scripts.zip"
path=shop.max2play.com/media/downloadable/currentversion/wolfsonkernel/

# Check Kernel Version! If > 4.0 get newer Kernel

if [ $(uname --all | grep " 4\.1\." | wc -l) -gt 0 ]; then
	wget -O /opt/max2play/cache/kernel.tgz cdn.max2play.com/pi/kernels/cirrus-linux-4.1.13.tgz
	tar xzf /opt/max2play/cache/kernel.tgz -C /
elif [ $(uname --all | grep " 4\.4\." | wc -l) -gt 0 ]; then
	# http://www.horus.com/~hias/cirrus-driver.html
	wget -O /opt/max2play/cache/kernel.tgz cdn.max2play.com/pi/kernels/cirrus-linux-4.4.14.tgz
	tar xzf /opt/max2play/cache/kernel.tgz -C /
elif [ "$1" ==  "none" ]; then
	echo "No Kernel Changes... Default Supported"
else	
	wget -O /opt/max2play/cache/kernel.deb $path$source
	dpkg -i /opt/max2play/cache/kernel.deb

	wget -O /boot/overlays/$overlay $path$overlay
fi

wget -O /opt/max2play/cache/$scripts $path$scripts
mkdir /opt/max2play/wolfson
unzip /opt/max2play/cache/$scripts -d /opt/max2play/wolfson
chmod -R 777 /opt/max2play/wolfson

# Soundkarte Namen ersetzen
if [ "$1" ==  "none" ]; then
   sed -i "s/sndrpiwsp/RPiCirrus/" /opt/max2play/wolfson/Playback_to_Speakers.sh
   sed -i "s/sndrpiwsp/RPiCirrus/" /opt/max2play/wolfson/Playback_to_Lineout.sh
   sed -i "s/sndrpiwsp/RPiCirrus/" /opt/max2play/wolfson/Playback_to_Headset.sh
   sed -i "s/sndrpiwsp/RPiCirrus/" /opt/max2play/wolfson/SPDIF_playback.sh
fi

if [ $(grep "arizona-ldo1" -i /etc/modprobe.d/raspi-blacklist.conf | wc -l) -lt "1" ]; then
	echo "softdep arizona-spi pre: arizona-ldo1" >> /etc/modprobe.d/raspi-blacklist.conf
	echo "softdep spi-bcm2708 pre: fixed" >> /etc/modprobe.d/raspi-blacklist.conf
	echo "softdep spi-bcm2835 pre: fixed" >> /etc/modprobe.d/raspi-blacklist.conf
fi

if [ $(grep "dtparam=spi=on" -i /boot/config.txt | wc -l) -lt "1" ]; then
	echo "dtparam=spi=on" >> /boot/config.txt
	echo "dtparam=i2c_arm=on" >> /boot/config.txt
fi

echo "finished - Reboot Needed";
