#!/bin/bash

# Move Build In Wifi Raspberry Pi 3 to wlan1 and back to wlan0

if [ "$1" == "wlan0" ]; then
	# remove entry for wlan1
	sed -i 's/^.*wlan1.*$//' /etc/udev/rules.d/70-persistent-net.rules
	echo "Interface wlan0 is now set to default"  
else
	echo "Add entry for wlan1 with address of wifi module"
	ADDRESS=$(LANG=C && sudo /sbin/ifconfig wlan0 | grep -o '\(HWaddr\|ether\) [0-9a-f\:]\+' | sed 's/HWaddr //;s/ether //')
	#sed -i "s/ATTR{address}==\"\*\"/ATTR{address}==\"$ADDRESS\"/;s/wlan0/wlan1/" /etc/udev/rules.d/70-persistent-net.rules
	echo "SUBSYSTEM==\"net\", ACTION==\"add\", DRIVERS==\"?*\", ATTR{address}==\"$ADDRESS\", ATTR{dev_id}==\"0x0\", ATTR{type}==\"1\", KERNEL==\"wlan*\", NAME=\"wlan1\"" >> /etc/udev/rules.d/70-persistent-net.rules
	echo "Build-In WiFi Interface is now wlan1"
fi

echo "finished - Reboot Needed";
